SystemOrganization addCategory: #Tp1_Abejas!
SystemOrganization addCategory: #'Tp1_Abejas-Tests'!

TestCase subclass: #ReinaTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1_Abejas-Tests'!

!ReinaTest commentStamp: '<historical>' prior: 0!
A ReinaTest is a test class for testing the behavior of Reina!

!ReinaTest methodsFor: 'tests-as yet unclassified' stamp: 'Facundo 6/6/2013 10:54'!
testRealizarTarea! !

Object subclass: #Abeja
	instanceVariableNames: 'aguijon'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1_Abejas'!

!Abeja methodsFor: 'accessing' stamp: 'Facundo 5/21/2013 17:30'!
aguijon
	^ aguijon! !

!Abeja methodsFor: 'accessing' stamp: 'Facundo 5/21/2013 17:30'!
aguijon: anObject
	aguijon := anObject! !

!Abeja methodsFor: 'as yet unclassified' stamp: 'Facundo 6/6/2013 11:48'!
comer: unaCantidad deNectarDe: unaColmena
^(unaCantidad <= unaColmena nectar)
	ifTrue: [unaColmena disminuirNectarEn: unaCantidad]
	ifFalse: [ Error signal: 'No se puede dar de comer a mas abejas ya que no alcanza la cantidad de nectar en la colmena' ].
! !

!Abeja methodsFor: 'as yet unclassified' stamp: 'Facundo 5/21/2013 17:22'!
puedePicar
^self aguijon.
! !

Abeja subclass: #Obrera
	instanceVariableNames: 'rol'
	classVariableNames: 'maximoMielALlevar'
	poolDictionaries: ''
	category: 'Tp1_Abejas'!

!Obrera class methodsFor: 'as yet unclassified' stamp: 'Facundo 6/6/2013 12:55'!
crearConRol: unRol
|nuevaObrera|
nuevaObrera := self new.
nuevaObrera rol: unRol.
^ nuevaObrera.! !

!Obrera class methodsFor: 'accessing' stamp: 'Facundo 6/7/2013 01:34'!
maximoMielALlevar
	^ maximoMielALlevar! !

!Obrera class methodsFor: 'accessing' stamp: 'Facundo 6/7/2013 01:34'!
maximoMielALlevar: anObject
	maximoMielALlevar := anObject! !

!Obrera methodsFor: 'as yet unclassified' stamp: 'Facundo 6/4/2013 01:09'!
initialize
self aguijon: true.! !

!Obrera methodsFor: 'as yet unclassified' stamp: 'Facundo 6/7/2013 01:23'!
picar: unaAbeja de: unaColmena
unaColmena sacarAbeja: unaAbeja.
! !

!Obrera methodsFor: 'as yet unclassified' stamp: 'Facundo 6/6/2013 10:49'!
realizarTarea:unaColmena
self rol realizarTarea: unaColmena.! !

!Obrera methodsFor: 'accessing' stamp: 'Facundo 6/6/2013 12:07'!
rol
	^ rol! !

!Obrera methodsFor: 'accessing' stamp: 'Facundo 6/6/2013 12:07'!
rol: anObject
	rol := anObject! !

Abeja subclass: #Reina
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1_Abejas'!

Reina class
	instanceVariableNames: 'cantidadParaReproducirZanganos cantidadParaReproducir'!

Reina class
	instanceVariableNames: 'cantidadParaReproducirZanganos cantidadParaReproducir'!

!Reina methodsFor: 'as yet unclassified' stamp: 'Facundo 5/24/2013 11:33'!
initialize
self aguijon: false.! !

!Reina methodsFor: 'as yet unclassified' stamp: 'Facundo 6/6/2013 12:26'!
realizarTarea: unaColmena 
|cantidadParaReproducir cantidadParaReproducirZanganos cantidadParaReproducirObreras|

cantidadParaReproducir := ((unaColmena nectar) * 0.3) asInteger.
cantidadParaReproducirZanganos := (cantidadParaReproducir * 0.2) asInteger.
cantidadParaReproducirObreras := (cantidadParaReproducir * 0.8) asInteger.

cantidadParaReproducirZanganos timesRepeat: [ unaColmena agregarAbeja: Zangano new ].
(cantidadParaReproducirObreras // 2) timesRepeat: [ unaColmena agregarAbeja: ((Obrera new) rol: Pecoreadora new) ].
(cantidadParaReproducirObreras // 2) timesRepeat: [ unaColmena agregarAbeja: ((Obrera new) rol: Guardiana new)] .! !

Abeja subclass: #Zangano
	instanceVariableNames: 'corrienteDeAire'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1_Abejas'!

!Zangano class methodsFor: 'as yet unclassified' stamp: 'Facundo 6/6/2013 12:57'!
crearConCorrienteDeAire: unaCorriente
|nuevoZangano|
nuevoZangano := self new.
nuevoZangano corrienteDeAire: unaCorriente.
^ nuevoZangano.! !

!Zangano methodsFor: 'accessing' stamp: 'Facundo 5/23/2013 00:45'!
corrienteDeAire
	^ corrienteDeAire! !

!Zangano methodsFor: 'accessing' stamp: 'Facundo 5/23/2013 00:45'!
corrienteDeAire: anObject
	corrienteDeAire := anObject! !

!Zangano methodsFor: 'as yet unclassified' stamp: 'Facundo 5/24/2013 11:34'!
initialize 
self aguijon: false.! !

!Zangano methodsFor: 'as yet unclassified' stamp: 'Facundo 6/6/2013 10:53'!
realizarTarea: unaColmena
unaColmena reducirTemperaturaEn: self corrienteDeAire.
"deshidratar el nectar?"! !

Object subclass: #Almacenadora
	instanceVariableNames: ''
	classVariableNames: 'cantidadDeNectarATomar'
	poolDictionaries: ''
	category: 'Tp1_Abejas'!

!Almacenadora class methodsFor: 'accessing' stamp: 'Facundo 6/6/2013 16:15'!
cantidadDeNectarATomar
	^ cantidadDeNectarATomar! !

!Almacenadora class methodsFor: 'accessing' stamp: 'Facundo 6/6/2013 16:15'!
cantidadDeNectarATomar: anObject
	cantidadDeNectarATomar := anObject! !

!Almacenadora methodsFor: 'as yet unclassified' stamp: 'Facundo 6/6/2013 15:08'!
realizarTarea: unaColmena
unaColmena aumentarMiel: (cantidadDeNectarATomar // 2).! !

Object subclass: #Apiario
	instanceVariableNames: 'colmenas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1_Abejas'!

!Apiario class methodsFor: 'as yet unclassified' stamp: 'Facundo 6/6/2013 13:00'!
crearConColmenas: unasColmenas
|nuevoApiario|
nuevoApiario := self new.
nuevoApiario colmenas addAll: unasColmenas.
^ nuevoApiario.! !

!Apiario methodsFor: 'accessing' stamp: 'Facundo 5/22/2013 21:08'!
colmenaMasFuerte
^ (self colmenas asSortedCollection: [:unaColmena :otraColmena | unaColmena cuantasPican >= otraColmena cuantasPican]) first.! !

!Apiario methodsFor: 'accessing' stamp: 'Facundo 5/21/2013 17:38'!
colmenas
	^ colmenas! !

!Apiario methodsFor: 'accessing' stamp: 'Facundo 5/21/2013 17:38'!
colmenas: anObject
	colmenas := anObject! !

!Apiario methodsFor: 'accessing' stamp: 'Facundo 6/6/2013 12:58'!
initialize
colmenas := Bag new.! !

Object subclass: #Colmena
	instanceVariableNames: 'abejas floresCercanas nectar piquera temperatura miel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1_Abejas'!

!Colmena class methodsFor: 'as yet unclassified' stamp: 'Facundo 6/6/2013 13:08'!
crearConAbejas: unasAbejas conFlores: floresCercanas conNectar: nectar conPiquera: piquera conTemp: temperatura
|nuevaColmena|
nuevaColmena := self new.
nuevaColmena abejas addAll: unasAbejas.
nuevaColmena floresCercanas addAll: floresCercanas.
nuevaColmena nectar: nectar.
nuevaColmena piquera: piquera.
nuevaColmena temperatura: temperatura.
^ nuevaColmena.
! !

!Colmena class methodsFor: 'as yet unclassified' stamp: 'Facundo 6/7/2013 01:03'!
crearConAbejas: unasAbejas conFlores: floresCercanas conNectar: nectar conPiquera: piquera conTemp: temperatura conMiel: miel
|nuevaColmena|
nuevaColmena := self new.
nuevaColmena abejas addAll: unasAbejas.
nuevaColmena floresCercanas addAll: floresCercanas.
nuevaColmena nectar: nectar.
nuevaColmena piquera: piquera.
nuevaColmena temperatura: temperatura.
nuevaColmena miel: miel.
^ nuevaColmena.
! !

!Colmena methodsFor: 'accessing' stamp: 'Facundo 5/21/2013 17:38'!
abejas
	^ abejas! !

!Colmena methodsFor: 'accessing' stamp: 'Facundo 5/21/2013 17:38'!
abejas: anObject
	abejas := anObject! !

!Colmena methodsFor: 'as yet unclassified' stamp: 'Facundo 6/6/2013 11:12'!
agregarAbeja: unaAbeja
self abejas add: unaAbeja.! !

!Colmena methodsFor: 'as yet unclassified' stamp: 'Facundo 5/21/2013 20:17'!
alcanzaNectar: unaCantidad
^(unaCantidad <= self nectar)


	
! !

!Colmena methodsFor: 'as yet unclassified' stamp: 'Facundo 6/6/2013 15:09'!
aumentarMiel: unaCantidad
self miel: (self miel + unaCantidad).! !

!Colmena methodsFor: 'as yet unclassified' stamp: 'Facundo 5/21/2013 18:03'!
aumentarNectarEn: unaCantidad.
self nectar:  (self nectar + unaCantidad).! !

!Colmena methodsFor: 'as yet unclassified' stamp: 'Facundo 5/21/2013 20:36'!
comanNectar: unaCantidad
^[self abejas do: [:unaAbeja | unaAbeja comer: unaCantidad deNectarDe: self]] on: Error do: [:e | e messageText].! !

!Colmena methodsFor: 'as yet unclassified' stamp: 'Facundo 6/4/2013 01:20'!
cuantasPican
^self abejas count: [:unaAbeja | unaAbeja puedePicar].! !

!Colmena methodsFor: 'as yet unclassified' stamp: 'Facundo 6/6/2013 15:19'!
disminuirMielEn: unaCantidad
self miel: self miel - unaCantidad.! !

!Colmena methodsFor: 'as yet unclassified' stamp: 'Facundo 5/21/2013 18:57'!
disminuirNectarEn: unaCantidad.
self nectar:  (self nectar - unaCantidad).! !

!Colmena methodsFor: 'as yet unclassified' stamp: 'Facundo 6/5/2013 23:58'!
elegirFlor
"la primera que tenga nectar"
^(self floresCercanas asOrderedCollection) first.! !

!Colmena methodsFor: 'as yet unclassified' stamp: 'Facundo 6/7/2013 01:43'!
esFuerte
^ self cuantasPican > 0.! !

!Colmena methodsFor: 'accessing' stamp: 'Facundo 5/21/2013 17:55'!
floresCercanas
	^ floresCercanas! !

!Colmena methodsFor: 'accessing' stamp: 'Facundo 5/21/2013 17:55'!
floresCercanas: anObject
	floresCercanas := anObject! !

!Colmena methodsFor: 'as yet unclassified' stamp: 'Facundo 6/6/2013 13:09'!
initialize
abejas := Bag new.
floresCercanas := Bag new.! !

!Colmena methodsFor: 'accessing' stamp: 'Facundo 6/6/2013 15:08'!
miel
	^ miel! !

!Colmena methodsFor: 'accessing' stamp: 'Facundo 6/6/2013 15:08'!
miel: anObject
	miel := anObject! !

!Colmena methodsFor: 'accessing' stamp: 'Facundo 5/21/2013 18:02'!
nectar
	^ nectar! !

!Colmena methodsFor: 'accessing' stamp: 'Facundo 5/21/2013 18:02'!
nectar: anObject
	nectar := anObject! !

!Colmena methodsFor: 'as yet unclassified' stamp: 'Facundo 6/4/2013 17:00'!
perteneceAColmena: unaAbeja
^self abejas includes: unaAbeja.! !

!Colmena methodsFor: 'as yet unclassified' stamp: 'Facundo 6/7/2013 01:35'!
pillarA: unaColmena
|atacantes obrerasColmenaDefensa guardianasColmenaDefensa|
atacantes := self abejas select: [ : unaAbeja | unaAbeja puedePicar].
obrerasColmenaDefensa := unaColmena abejas select:[:unaAbeja | unaAbeja isMemberOf: Obrera].
guardianasColmenaDefensa := obrerasColmenaDefensa select: [ :unaGuardiana | unaGuardiana rol isMemberOf: Guardiana ].
(atacantes size > guardianasColmenaDefensa size)
	ifTrue: [ unaColmena abejas removeAllSuchThat: [:unaAbeja | guardianasColmenaDefensa includes: unaAbeja].
				(atacantes size - guardianasColmenaDefensa size) timesRepeat: [
					unaColmena disminuirMielEn: Obrera maximoMielALlevar.
					self aumentarMiel: Obrera maximoMielALlevar.]].
! !

!Colmena methodsFor: 'accessing' stamp: 'Facundo 5/22/2013 12:38'!
piquera
	^ piquera! !

!Colmena methodsFor: 'accessing' stamp: 'Facundo 5/22/2013 12:38'!
piquera: anObject
	piquera := anObject! !

!Colmena methodsFor: 'as yet unclassified' stamp: 'Facundo 6/6/2013 10:52'!
realicenTarea
self abejas do: [ :unaAbeja | unaAbeja realizarTarea: self ].! !

!Colmena methodsFor: 'as yet unclassified' stamp: 'Facundo 5/23/2013 00:45'!
reducirTemperaturaEn: unaCantidad
self temperatura: (self temperatura - unaCantidad).
! !

!Colmena methodsFor: 'as yet unclassified' stamp: 'Facundo 6/6/2013 11:45'!
sacarAbeja: unaAbeja
self abejas remove: unaAbeja.! !

!Colmena methodsFor: 'accessing' stamp: 'Facundo 5/23/2013 00:43'!
temperatura
	^ temperatura! !

!Colmena methodsFor: 'accessing' stamp: 'Facundo 5/23/2013 00:43'!
temperatura: anObject
	temperatura := anObject! !

Object subclass: #Flor
	instanceVariableNames: 'nectar distanciaAColmena'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1_Abejas'!

!Flor class methodsFor: 'as yet unclassified' stamp: 'Facundo 6/6/2013 13:02'!
crearConNectar: unaCantidad
|nuevaFlor|
nuevaFlor := self new.
nuevaFlor nectar: unaCantidad.
^ nuevaFlor.! !

!Flor methodsFor: 'accessing' stamp: 'Facundo 5/21/2013 18:23'!
disminuirNectarEn: unaCantidad
self nectar: (self nectar - unaCantidad).! !

!Flor methodsFor: 'accessing' stamp: 'Facundo 5/21/2013 18:14'!
nectar
	^ nectar! !

!Flor methodsFor: 'accessing' stamp: 'Facundo 5/21/2013 18:14'!
nectar: anObject
	nectar := anObject! !

!Flor methodsFor: 'accessing' stamp: 'Facundo 6/6/2013 15:47'!
quitarNectarConMaximoDe: unaCantidad
^(self nectar > unaCantidad)
	ifTrue: [ unaCantidad ]
	ifFalse: [ self nectar].! !

Object subclass: #Guardiana
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1_Abejas'!

!Guardiana methodsFor: 'accessing' stamp: 'Facundo 6/7/2013 00:23'!
buscar: unaGuardiana En: unaColmena
|obreras|
obreras := unaColmena abejas select: [ :unaAbeja | unaAbeja isMemberOf: Obrera ].
^ obreras detect:[ : unaAbeja | unaAbeja rol = unaGuardiana].! !

!Guardiana methodsFor: 'accessing' stamp: 'Facundo 6/6/2013 11:59'!
buscarIntrusasEn: unaColmena
^ unaColmena piquera abejas select: [ :unaAbejaDePiquera | (self esIntrusa: unaAbejaDePiquera De: unaColmena) not].
"unaColmena piquera abejas detect: [ :unaAbejaDePiquera | (unaColmena abejas includes: unaAbejaDePiquera) not]."
! !

!Guardiana methodsFor: 'accessing' stamp: 'Facundo 6/7/2013 00:45'!
esIntrusa: unaAbeja De: unaColmena
^ unaColmena abejas includes: unaAbeja.! !

!Guardiana methodsFor: 'accessing' stamp: 'Facundo 6/7/2013 00:16'!
picar: unaAbeja de: unaColmena
unaColmena piquera sacarAbeja: unaAbeja.
unaColmena piquera sacarAbeja: (self buscar: self En: unaColmena).
unaColmena sacarAbeja: (self buscar: self En: unaColmena).! !

!Guardiana methodsFor: 'accessing' stamp: 'Facundo 6/6/2013 16:55'!
picarSiHayIntrusa: unasAbejas De: unaColmena
(unasAbejas size> 0)
	ifTrue: [self picar: ((unasAbejas asOrderedCollection) first) de: unaColmena].! !

!Guardiana methodsFor: 'accessing' stamp: 'Facundo 6/6/2013 11:52'!
realizarTarea: unaColmena
self picarSiHayIntrusa: (self buscarIntrusasEn: unaColmena) De: unaColmena.! !

Object subclass: #Hormiguero
	instanceVariableNames: 'cantidadDeHormigas miel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1_Abejas'!

!Hormiguero class methodsFor: 'as yet unclassified' stamp: 'Facundo 6/7/2013 01:42'!
crearConHormigas: unaCantidad conMiel: miel
|nuevoHormiguero|
nuevoHormiguero := self new.
nuevoHormiguero cantidadDeHormigas: unaCantidad.
nuevoHormiguero miel: miel.
^ nuevoHormiguero.! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'Facundo 6/6/2013 15:17'!
atacarA: unaColmena
(self leAfectaElAtaqueA: unaColmena)
	ifTrue: [ 	unaColmena disminuirMielEn: self cantidadDeHormigas.
			 	self aumentarMielEn: self cantidadDeHormigas.].! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'Facundo 6/6/2013 15:19'!
aumentarMielEn: unaCantidad
self miel: self miel + unaCantidad.! !

!Hormiguero methodsFor: 'accessing' stamp: 'Facundo 6/6/2013 15:15'!
cantidadDeHormigas
	^ cantidadDeHormigas! !

!Hormiguero methodsFor: 'accessing' stamp: 'Facundo 6/6/2013 15:15'!
cantidadDeHormigas: anObject
	cantidadDeHormigas := anObject! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'Facundo 6/6/2013 15:57'!
leAfectaElAtaqueA: unaColmena. "cuando esta no es fuerte"
^ (unaColmena esFuerte) not. "Es fuerte si tiene abejas que pican ?"! !

!Hormiguero methodsFor: 'accessing' stamp: 'Facundo 6/6/2013 15:19'!
miel
	^ miel! !

!Hormiguero methodsFor: 'accessing' stamp: 'Facundo 6/6/2013 15:19'!
miel: anObject
	miel := anObject! !

Object subclass: #Pecoreadora
	instanceVariableNames: ''
	classVariableNames: 'nectarMaximoARecolectar'
	poolDictionaries: ''
	category: 'Tp1_Abejas'!

!Pecoreadora class methodsFor: 'accessing' stamp: 'Facundo 6/6/2013 15:54'!
nectarMaximoARecolectar
	^ nectarMaximoARecolectar! !

!Pecoreadora class methodsFor: 'accessing' stamp: 'Facundo 6/6/2013 15:54'!
nectarMaximoARecolectar: anObject
	nectarMaximoARecolectar := anObject! !

!Pecoreadora methodsFor: 'as yet unclassified' stamp: 'Facundo 6/6/2013 15:55'!
nectarRecolectadoDe: unaFlor
^ unaFlor quitarNectarConMaximoDe: Pecoreadora nectarMaximoARecolectar.

! !

!Pecoreadora methodsFor: 'as yet unclassified' stamp: 'Facundo 6/5/2013 23:09'!
realizarTarea: unaColmena
self recolectarDe: unaColmena elegirFlor yDepositarEn: unaColmena.! !

!Pecoreadora methodsFor: 'as yet unclassified' stamp: 'Facundo 6/6/2013 15:46'!
recolectarDe: unaFlor yDepositarEn: unaColmena
unaColmena aumentarNectarEn: (self nectarRecolectadoDe: unaFlor).
unaFlor disminuirNectarEn: (self nectarRecolectadoDe: unaFlor).! !

Object subclass: #Piquera
	instanceVariableNames: 'centimetros abejas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1_Abejas'!

!Piquera class methodsFor: 'as yet unclassified' stamp: 'Facundo 6/6/2013 13:03'!
crearConCentimetros: unaCantidad yAbejas: unasAbejas
|nuevaPiquera|
nuevaPiquera := self new.
nuevaPiquera centimetros: unaCantidad.
nuevaPiquera abejas addAll: unasAbejas.
^ nuevaPiquera.! !

!Piquera methodsFor: 'accessing' stamp: 'Facundo 5/22/2013 12:36'!
abejas
	^ abejas! !

!Piquera methodsFor: 'accessing' stamp: 'Facundo 5/22/2013 12:36'!
abejas: anObject
	abejas := anObject! !

!Piquera methodsFor: 'as yet unclassified' stamp: 'Facundo 6/7/2013 00:48'!
buscarGuardianaEnPiquera: unaColmena
|obreras|
obreras := unaColmena piquera abejas select: [ :unaAbeja | unaAbeja isMemberOf: Obrera ].
^ obreras detect: [ : unaAbeja | unaAbeja rol isMemberOf: Guardiana ].! !

!Piquera methodsFor: 'accessing' stamp: 'Facundo 5/22/2013 12:24'!
centimetros
	^ centimetros! !

!Piquera methodsFor: 'accessing' stamp: 'Facundo 5/22/2013 12:24'!
centimetros: anObject
	centimetros := anObject! !

!Piquera methodsFor: 'as yet unclassified' stamp: 'Facundo 6/6/2013 13:05'!
initialize
abejas := Bag new.! !

!Piquera methodsFor: 'as yet unclassified' stamp: 'Facundo 6/4/2013 02:19'!
intentaPasar: unaAbeja
|guardiana|
guardiana := Guardiana new.
guardiana initialize.
guardiana colmena: self colmena.
self abejas add: guardiana.
"((self abejas select:[:unaA | unaA == guardiana]) asOrderedCollection first) picarSiHayIntrusa: {unaAbeja}."
self colmena abejas add: guardiana. "self colmena agregarAbeja: guardiana."
guardiana picarSiHayIntrusa: {unaAbeja}
! !

!Piquera methodsFor: 'as yet unclassified' stamp: 'Facundo 6/7/2013 00:47'!
intentaPasar: unaAbeja A: unaColmena
|guardiana|
guardiana := self buscarGuardianaEnPiquera: unaColmena.
((guardiana rol esIntrusa: unaAbeja De: unaColmena) not)
	ifTrue: [guardiana rol picar: unaAbeja de: unaColmena.].

! !

!Piquera methodsFor: 'as yet unclassified' stamp: 'Facundo 5/22/2013 13:19'!
sacarAbeja: unaAbeja 
self abejas remove: unaAbeja.! !

Object subclass: #Varroa
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1_Abejas'!

!Varroa methodsFor: 'as yet unclassified' stamp: 'Facundo 6/6/2013 16:20'!
atacarA: unaColmena
|obreras pecoreadoras zanganos almacenadoras|

obreras := unaColmena abejas select: [ : unaAbeja | unaAbeja isMemberOf: Obrera ].
pecoreadoras := obreras select: [ :unaObrera | unaObrera rol isMemberOf: Pecoreadora ].
zanganos := unaColmena abejas select: [ : unaAbeja | unaAbeja isMemberOf: Zangano ].
almacenadoras := obreras select: [ :unaObrera | unaObrera rol isMemberOf: Almacenadora ].

pecoreadoras do: [ :unaPecoreadora | unaPecoreadora nectarMaximoARecolectar: unaPecoreadora nectarMaximoARecolectar * 0.3 ].
zanganos do: [ :unZangano | unZangano corrienteDeAire: unZangano corrienteDeAire * 0.2 ].
almacenadoras do:[ : unaAlmacenadora | unaAlmacenadora cantidadDeNectarATomar: unaAlmacenadora cantidadDeNectarATomar * 0.15].

unaColmena abejas removeAll.
unaColmena abejas addAll: pecoreadoras.
unaColmena abejas addAll: zanganos.
unaColmena abejas addAll: almacenadoras.! !

Varroa subclass: #VarroaDestructora
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1_Abejas'!

!VarroaDestructora methodsFor: 'as yet unclassified' stamp: 'Facundo 6/6/2013 16:24'!
atacarA: unaColmena
|almacenadoras obreras|
super atacarA: unaColmena.
obreras := unaColmena abejas select: [ :unaAbeja | unaAbeja isMemberOf: Obrera ].
almacenadoras := obreras select: [ :unaAlmacenadora | unaAlmacenadora rol isMemberOf: Almacenadora ].
! !
